
-- generated by elm_rs


module EncodeDecode exposing (..)

import Dict exposing (Dict)
-- import Http
import Json.Decode
import Json.Encode
import Url.Builder


resultEncoder : (e -> Json.Encode.Value) -> (t -> Json.Encode.Value) -> (Result e t -> Json.Encode.Value)
resultEncoder errEncoder okEncoder enum =
    case enum of
        Ok inner ->
            Json.Encode.object [ ( "Ok", okEncoder inner ) ]
        Err inner ->
            Json.Encode.object [ ( "Err", errEncoder inner ) ]


resultDecoder : Json.Decode.Decoder e -> Json.Decode.Decoder t -> Json.Decode.Decoder (Result e t)
resultDecoder errDecoder okDecoder =
    Json.Decode.oneOf
        [ Json.Decode.map Ok (Json.Decode.field "Ok" okDecoder)
        , Json.Decode.map Err (Json.Decode.field "Err" errDecoder)
        ]


type UpMsg
    = LandingUpMsg (LandingUpMsg)
    | TermUpMsg (TermUpMsg)


upMsgEncoder : UpMsg -> Json.Encode.Value
upMsgEncoder enum =
    case enum of
        LandingUpMsg inner ->
            Json.Encode.object [ ( "LandingUpMsg", landingUpMsgEncoder inner ) ]
        TermUpMsg inner ->
            Json.Encode.object [ ( "TermUpMsg", termUpMsgEncoder inner ) ]

type TermUpMsg
    = RequestFullTermState
    | CloseTerm
    | RequestIncrementalTermStateUpdate
    | SendCharacter (String)


termUpMsgEncoder : TermUpMsg -> Json.Encode.Value
termUpMsgEncoder enum =
    case enum of
        RequestFullTermState ->
            Json.Encode.string "RequestFullTermState"
        CloseTerm ->
            Json.Encode.string "CloseTerm"
        RequestIncrementalTermStateUpdate ->
            Json.Encode.string "RequestIncrementalTermStateUpdate"
        SendCharacter inner ->
            Json.Encode.object [ ( "SendCharacter", Json.Encode.string inner ) ]

type LandingUpMsg
    = RequestGreet (String)


landingUpMsgEncoder : LandingUpMsg -> Json.Encode.Value
landingUpMsgEncoder enum =
    case enum of
        RequestGreet inner ->
            Json.Encode.object [ ( "RequestGreet", Json.Encode.string inner ) ]

type DownMsg
    = LandingDownMsg (LandingDownMsg)
    | TermDownMsg (TermDownMsg)


downMsgDecoder : Json.Decode.Decoder DownMsg
downMsgDecoder =
    Json.Decode.oneOf
        [ Json.Decode.map LandingDownMsg (Json.Decode.field "LandingDownMsg" (landingDownMsgDecoder))
        , Json.Decode.map TermDownMsg (Json.Decode.field "TermDownMsg" (termDownMsgDecoder))
        ]

type TermDownMsg
    = TermUpdate (TerminalScreen)
    | BackendTermStartFailure (String)
    | TermNotStarted


termDownMsgDecoder : Json.Decode.Decoder TermDownMsg
termDownMsgDecoder =
    Json.Decode.oneOf
        [ Json.Decode.map TermUpdate (Json.Decode.field "TermUpdate" (terminalScreenDecoder))
        , Json.Decode.map BackendTermStartFailure (Json.Decode.field "BackendTermStartFailure" (Json.Decode.string))
        , Json.Decode.string
            |> Json.Decode.andThen
                (\x ->
                    case x of
                        "TermNotStarted" ->
                            Json.Decode.succeed TermNotStarted
                        unexpected ->
                            Json.Decode.fail <| "Unexpected variant " ++ unexpected
                )
        ]

type alias TerminalScreen =
    { cols : Int
    , rows : Int
    , damagedLines : List (Line)
    , cursorLoc : Cursor
    }


terminalScreenDecoder : Json.Decode.Decoder TerminalScreen
terminalScreenDecoder =
    Json.Decode.succeed TerminalScreen
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "cols" (Json.Decode.int)))
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "rows" (Json.Decode.int)))
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "damaged_lines" (Json.Decode.list (lineDecoder))))
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "cursor_loc" (cursorDecoder)))


type alias Cursor =
    { row : Int
    , col : Int
    }


cursorDecoder : Json.Decode.Decoder Cursor
cursorDecoder =
    Json.Decode.succeed Cursor
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "row" (Json.Decode.int)))
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "col" (Json.Decode.int)))


type alias Line =
    { line : Int
    , content : String
    }


lineDecoder : Json.Decode.Decoder Line
lineDecoder =
    Json.Decode.succeed Line
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "line" (Json.Decode.int)))
        |> Json.Decode.andThen (\x -> Json.Decode.map x (Json.Decode.field "content" (Json.Decode.string)))


type LandingDownMsg
    = Greeting (String)
    | TimeUpdate (String)


landingDownMsgDecoder : Json.Decode.Decoder LandingDownMsg
landingDownMsgDecoder =
    Json.Decode.oneOf
        [ Json.Decode.map Greeting (Json.Decode.field "Greeting" (Json.Decode.string))
        , Json.Decode.map TimeUpdate (Json.Decode.field "TimeUpdate" (Json.Decode.string))
        ]

